clc
clear all
close all

%m es la posicion del parche en la coordenada x
%n es la posicion del parche en la coordenada y

f = 10e9;
m = 1:38;
n = 1:38;
d = 0.02;
h = 2.5;
lambda = 3e8/f;
k = 2*pi/lambda;

feedpos = [19 19];
% feedpos = ceil([length(m)/2 length(n)/2]);


[M N] = meshgrid(m,n);

% Calculamos la distancia entre feed y los parches teniendo en cuenta D 

b = sqrt((feedpos(1)-M).^2+(feedpos(2)-N).^2).*d; %Posible error en el uso de M y N
Dfeed = sqrt(b.^2 + h.^2);

theta_b = 0;
phi_b = pi/2;

PatchPhase = (2*pi*f/3e8)*(Dfeed-(M*cos(phi_b)+N*sin(phi_b))*sin(theta_b));

PatchPhase_Degrees = PatchPhase*360/(2*pi);

colormap(gray)
surf(M,N,ones(length(n),length(m)),(PatchPhase_Degrees-min(min(PatchPhase_Degrees))))
h = colorbar;
ylabel(h, 'Unit cell phase delay')
DM_Phase = (max(max(PatchPhase_Degrees))-min(min(PatchPhase_Degrees))) %Maxima diferencia de fase
xlabel('X axis elements')
ylabel('Y axis elements')



Vueltas = floor(PatchPhase/(2*pi));
Norm_PatchPhase = PatchPhase-(2*pi*(Vueltas+1));
Norm_PatchPhase_Degrees = Norm_PatchPhase*360/(2*pi);

figure
surf(M,N,ones(length(n),length(m)),Norm_PatchPhase_Degrees)
colormap(gray)
h = colorbar;
ylabel(h, 'Unit cell phase delay')
xlabel('X axis elements')
ylabel('Y axis elements')

Norm_PatchPhase_aux = Norm_PatchPhase';
PatchPhase_aux = PatchPhase';
%%
%Para radiacin normal a la superficie (broadside)

b2 = sqrt((length(m)/2)^2+(length(n)/2)^2);

%Coordenadas esfericas

theta = linspace(-pi/2,pi/2,100);
phi = pi;
r = 1;

x = r*sin(theta)*cos(phi);
y = r*sin(theta)*sin(phi);
z = r*cos(theta);

for a = 1:length(m) %Hacemos el cambio de coordenadas para cada parche.
    for b = 1:length(n)
        
       xp(:,a,b)=x-m(a); 
       yp(:,a,b)=y-n(b);
       zp(:,a,b)=z;

    end
end

% % for a = 1:length(m) %Pasamos a coordenadas esfricas en cada parche. SEEMS TO BE USELESS WHY DID I DO THIS
% %     for b = 1:length(n)
% %         
% %         theta_p(:,a,b) = acos(zp(:,a,b)./sqrt(xp(:,a,b).^2+yp(:,a,b).^2+zp(:,a,b).^2));
% %         phi_p(:,a,b) = atan(yp(:,a,b)./xp(:,a,b));
% %         r_p(:,a,b) = sqrt(xp(:,a,b).^2 + yp(:,a,b).^2 + zp(:,a,b).^2);
% %         
% %     end
% % end

for a = 1:length(m)
    for b = 1:length(n)
        for u = 1:length(xp(:,a,b))
        
                FA(u,a,b) = exp(j*k*sqrt((d*(m(a)-feedpos(1))).^2+(d*(n(b)-feedpos(2))).^2) + d*[m(a) n(b)]*[xp(u,a,b);yp(u,a,b)] + j * PatchPhase_aux(m(a),n(b)));
        
        end
    end
end
        
for a = 1:length(FA(:,1,1))
    
     E(a) = sum(sum(FA(a,:,:)));

end

plot(theta,abs(E))

        





